
// ---- Ads banner ----
AdsBanner = function(list, mediaSelector, opts) {
    var _this = this;
    var _banners = list;
    var _media_selecor = mediaSelector;
    var _opts = (opts || {});

    var imageDelay = (_opts.imageDelaySecs || 10)*1000;
    var curBanner = null;
    var curBannerMedia = null;
    var bannerTimeout = 0;
    var bannerInterval = 0;
    var renewBanner = false;

    var video_selector = _media_selecor + " video";

    _this.init = function() {
        curBanner = null;
        curBannerMedia = null;
        renewBanner = false;
        if(_banners.length > 0) {

            startBannerLoop();

            if(_opts.onClickBanner) {
                $(mediaSelector).on('click', function() {
                    if(curBanner) {
                        _opts.onClickBanner(curBanner);
                    }
                });
            }
        }
    };

    function getBannerInnerMedia(tb) {
        //TODO: inner loop rotation on medias
        return tb.medias[0];
    }

    function getNextBannerMedia() {
        if(ssVisible) {
            var media = specialBannerOnScreenSaver((curBanner ? curBanner.streamType : null));
            if(media) {
                curBanner = null;
                return media;
            }
        }
        if(_banners.length > 0) {
            var len = _banners.length;
            var ind = (curBanner ? _banners.findIndex(function(e) { return (e.id === curBanner.id); }) : -1);
            var next = (ind+1)%len; // works also for -1
            var tb;

            while(next !== ind) {
                tb = _banners[next];
                if(checkUsableAD(tb)) {
                    curBanner = tb;
                    return getBannerInnerMedia(tb);
                }
                next = (next+1)%len;

                if(ind == -1 && next == 0) {
                    // we did all the list
                    break;
                }
            }

            return (curBanner ? getBannerInnerMedia(curBanner) : null); // the current one

        }

        curBanner = null;
        return null;
    }

    function nextBanner() {
        clearTimeout(bannerTimeout);

        var media = getNextBannerMedia();

        if (media) {

            if(media !== curBannerMedia) {
                if (curBannerMedia && curBannerMedia.type == "VIDEO") {
                    $(video_selector)[0].src = "";
                }

                curBannerMedia = media;

                $(_media_selecor).html(getLinkEmbedHtml(media.link, media.type));

                if(media.type === "VIDEO") {
                    $(video_selector).on("ended", _this.needRenewBanner);
                } else {
                    bannerTimeout = setTimeout(_this.needRenewBanner, imageDelay);
                }

            } else {

                if(curBannerMedia && curBannerMedia.type === "VIDEO") {
                    $(video_selector)[0].pause();

                    bannerTimeout = setTimeout(function () {
                        $(video_selector)[0].src = "";
                        curBannerMedia = null;
                        _this.needRenewBanner();
                    }, 2000);

                } else {
                    curBannerMedia = null;
                    bannerTimeout = setTimeout(_this.needRenewBanner, imageDelay);
                }
            }

        } else {
            if(curBannerMedia && curBannerMedia.type == "VIDEO") {
                $(video_selector)[0].pause();
                $(video_selector)[0].src = "";
            }
            curBannerMedia = null;
            bannerTimeout = setTimeout(_this.needRenewBanner, imageDelay);
        }
    }

    _this.needRenewBanner = function() {
        renewBanner = true;
    };

    function startBannerLoop () {
        stopBannerLoop();

        renewBanner = true;
        bannerInterval = setInterval(function(){
            if(renewBanner) {
                renewBanner = false;
                nextBanner();
            }
        }, 1000);
    }

    function stopBannerLoop() {
        clearTimeout(bannerTimeout);
        bannerTimeout = 0;

        renewBanner = false;
        clearInterval(bannerInterval);
        bannerInterval = 0;

        if(curBannerMedia && curBannerMedia.type == "VIDEO") {
            $(video_selector)[0].pause();
            $(video_selector)[0].src = "";
        }
        $(_media_selecor).html("");
        curBannerMedia = null;
    }
};

AdsBanner.prototype.constructor = AdsBanner;