
function getADsForStream(streamType) {
    var ads = (window.getAdsData().ads || []);

    //TODO: do we check start, end dates: NO to be done by the displayer (on getNextxxx)
    return ads.filter(function(e) {
        return (e.active === true && e.streamType === streamType && e.appType === appType);
    });
}

function checkUsableAD(elem) {
    // media is mandatory for ads
    if(elem.active && elem.medias && elem.medias.length > 0) {
        var now = new Date();
        var curTime = now.getTime();
        var sd = (elem.startDate ? Date.parse(elem.startDate) : 0);
        var ed = (elem.endDate ? Date.parse(elem.endDate) : 0);

        if(sd > curTime || (ed > 0 && ed < curTime)) {
            return false;
        }

        var dparting = elem.dayParting;
        if(dparting && dparting.length === 7) {
            var day = now.getDay();
            var hour = now.getHours();

            if(dparting[day] > 0 && ((1 << hour) & dparting[day]) === 0) {
                return false;
            }
        }

        // for ADs we only have ONE group
        if(typeof(playerGroup) !== "undefined" && playerGroup) {
            var group = elem.group;
            if(group && group.length > 0 && playerGroup !== group) {
                return false;
            }
        }

        var players = elem.players;
        if(players && players.length > 0 && players.indexOf(playerName) < 0) {
            return false;
        }

        return true;
    }

    return false;
}

function getLinkEmbedHtml(link, type) {
    if (type === "IMAGE") {
        return ("<img src='" + baseOpts.mediaBaseUrl + link + "' alt=''>");
    } else if (type === "VIDEO") {
        return ("<video width='100%' height='100%' autoplay muted src='" + baseOpts.mediaBaseUrl + link + "'/>");

    } else if (type === "URL") {
        return ("<iframe src='" + link + "' style='pointer-events:none; touch-action:none; width:100%; min-height:500px;overflow:scroll;' scrolling='yes'>");
    }
    return "";
}
