
$(document).ready(function(e) {

    var _data = {
        ads: []
    };
    var dumversion = "?v=" + Date.now();

    function logToNative(action, eId, eLabel) {
        var url = "#" + action;
        if(eId) {
            url += (":" + eId);
            if (eLabel) {
                url += ("|" + eLabel);
            }
        }
        window.document.location.href = url;

        return false;
    }

    $.ajax({
        method: "GET",
        dataType: "json",
        data: null,
        cache: false,
        url:  baseOpts.siteBaseUrl + "cache/data.json" + dumversion,
        success: function(result) {
            _data = result;
            logToNative("appLoaded");
        },
        error: function (jqXHR, textStatus, errorThrown) {
            console.log("Error: Loading content file.");
        }
    });

    window.getAdsData = function() {
        return _data;
    };

    window.onNativeNoInteractionTimeout = function() {
    };

    window.onNativeAppLoaded = function(json) {
        var obj = (json || {});

        if(obj.playerName) {
            playerName = obj.playerName;
        }
        populateData();
    };

    if(document.getElementById("date")) {
        setInterval(showDateTime, 2 * 1000);
        showDateTime();
    }
    initWeatherWidget();
});

function populateData() {
    initAdBanners();
}

function showDateTime() {
    var date = moment();
    var strDate = date.format(baseOpts.dateFormat);
    var strTime = date.format(baseOpts.timeFormat);
    $("#date").html(strDate);
    $("#time").html(strTime);
}

var weather = null;

function initWeatherWidget() {
    if(document.getElementById("weather-temp")) {
        weather = new WeatherWidget();
        weather.init({
            descSelector: "#weather-description",
            iconSelector: "#weather-icon",
            tempSelector: "#weather-temp",
            city: "Dubai",
            language: "en"
        });
        weather.startUpdateLoop();
    }
}
