const baseOpts = {
    siteBaseUrl: "/",
    mediaBaseUrl: "/cache",
    dateFormat: "ddd, DD MMM",
    timeFormat: "HH:mm",
    imageDelaySecs: 10,
    fadeDelayMilliSecs: 800, // ATTENTION: it is in MILLI seconds. reminder: 1 sec = 1000 millisecs
    weatherCity: "Dubai, AE"
};


/*
 imageDelaySecs:
 the delay in SECONDS to display and image
 it is overridden by the delay set inside the media itself (See the CMS/ADs)
 ONLY applies to image medias
 default value 10 secs

 fadeDelayMilliSecs:
 this is the delay in MILLI secs for the previous media to fade out
 and the delay for the next media to fade in. So the total transition is 2 times this delay
 max value is 2000 (2 secs)
 default value 0 (no fade in/out)
 if set to a value < 10, NO fade In/Out
 it is the same delay for all the banners on the screen

 weatherCity:
 location to use for the weather widget.
 Mandatory to initialize the weather widget
 check https://openweathermap.org/
 */