WeatherWidget = function () {
    var _this = this;

    var apiKey;
    var city;
    var descSelector;
    var tempSelector;
    var iconSelector;
    var updateInterval;
    var updateIntervalTime;
    var cache;
    var curLang = "en";

    _this.init = function(opts) {
        apiKey = opts.apiKey || "b66c70231dd1b33d2430b64b47cb0174";
        city = opts.city || "Dubai";
        updateIntervalTime = (opts.updateIntervalTimeSecs || 3600)*1000;
        descSelector = opts.descSelector;
        tempSelector = opts.tempSelector;
        iconSelector = opts.iconSelector;
        curLang = (opts.language || "en").toLowerCase();
    };

    _this.getWeather = function() {
        $.getJSON("http://api.openweathermap.org/data/2.5/weather?lang="+curLang+"&q=" + city + "&units=Metric" + "&APPID=" + apiKey, function(data) {
            cache = data;
            $(descSelector).html(data["weather"][0]["description"]);
            $(tempSelector).html(Math.ceil(data["main"]["temp"]) + "°");
            $(iconSelector).html('<i class="' + getIcon(data) + '"></i>');
        }).fail(function() {
            if (cache) {
                $(descSelector).html(cache["weather"][0]["description"]);
                $(tempSelector).html(cache["main"]["temp"] + "°");
                $(iconSelector).html('<i class="' + getIcon(cache) + '"></i>');
            }
        })
    };

    _this.startUpdateLoop = function() {
        _this.stopUpdateLoop();
        _this.getWeather();
        updateInterval = setInterval(function() {
            _this.getWeather();
        }, updateIntervalTime);
    };

    _this.stopUpdateLoop = function() {
        clearInterval(updateInterval);
    };

    _this.setLanguage = function(lang) {
        if(lang) {
            var l = lang.toLowerCase();
            if(l != lang) {
                curLang = l
                _this.getWeather();
            }
        }
    };

    function getIcon(resp) {
        var prefix = 'wi wi-';
        var code = resp.weather[0].id;
        var icon = weatherIcons[0][code].icon;
        // add a day/night prefix depending on the received code
        if (!(code > 699 && code < 800) && !(code > 899 && code < 1000)) {
            icon = 'day-' + icon;
        }
        icon = prefix + icon;
        return icon;
    }
};

WeatherWidget.prototype.constructor = WeatherWidget;